#!/usr/bin/perl
#
# Firewall Tester listener daemon v.0.1
# by Andrea Barisani (lcars@infis.univ.trieste.it)

use strict;
use Net::PcapUtils;
use NetPacket::Ethernet qw(:strip);
use NetPacket::IP qw(:strip);
use NetPacket::TCP;
use NetPacket::UDP;
use NetPacket::ICMP;

open (OUT,">>./ftestd.log") || die "cannot create log file";
print OUT ("# Ftestd started on ".`date`);

sub process_pkt {
	my ($arg, $hdr, $pkt) = @_;
	my $ip_obj = NetPacket::IP->decode(eth_strip($pkt));
        my $tcp_obj = NetPacket::TCP->decode(ip_strip(eth_strip($pkt)));
        my $udp_obj = NetPacket::UDP->decode(ip_strip(eth_strip($pkt)));
        my $icmp_obj = NetPacket::ICMP->decode(ip_strip(eth_strip($pkt)));
	
	
	if ($tcp_obj->{data} =~ /ftestertcpprobe/ ) {
			open (OUT,">>./ftestd.log");
			print OUT ("$ip_obj->{src_ip}:$tcp_obj->{src_port} > $ip_obj->{dest_ip}:$tcp_obj->{dest_port} $tcp_obj->{flags} TCP\n");
		}
		
	if ($udp_obj->{data} =~ /ftesterudpprobe/ ) {
			open (OUT,">>./ftestd.log");
			print OUT ("$ip_obj->{src_ip}:$udp_obj->{src_port} > $ip_obj->{dest_ip}:$udp_obj->{dest_port} UDP\n");
		}
			
	if ($icmp_obj->{data} =~ /ftestericmpprobe/ ) {
			open (OUT,">>./ftestd.log");
			print OUT ("$ip_obj->{src_ip} > $ip_obj->{dest_ip} ICMP $icmp_obj->{type} $icmp_obj->{code}\n");
		}

	if ($tcp_obj->{data} =~ /ftesterstop/ ) {
			print OUT ("$ip_obj->{src_ip}:$tcp_obj->{src_port} > $ip_obj->{dest_ip}:$tcp_obj->{dest_port} $tcp_obj->{flags} TCP\n");
			print OUT ("# Ftestd finished on ".`date`);
			close(OUT);
			die "received disconnection signal";
		}
	}

Net::PcapUtils::loop(\&process_pkt, FILTER => 'ip');

